/************************************************************************************/
/*  Program name CAPFAEXT_DIST_HIST.sql                                             */
/*  Creater:  NIP Karen (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 28 DEC, 2005   NIP Karen         First created                                   */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAEXT_DIST_HIST';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFA_DIST_HIST.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		*
	FROM
		FA_DISTRIBUTION_HISTORY
	WHERE	SUBSTR(Book_Type_Code,1,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.DISTRIBUTION_ID||CHR(9)||
				C1.BOOK_TYPE_CODE||CHR(9)||
				C1.ASSET_ID||CHR(9)||
				C1.UNITS_ASSIGNED||CHR(9)||
				C1.DATE_EFFECTIVE||CHR(9)||
				C1.CODE_COMBINATION_ID||CHR(9)||
				C1.LOCATION_ID||CHR(9)||
				C1.TRANSACTION_HEADER_ID_IN||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
				C1.LAST_UPDATED_BY||CHR(9)||
				C1.DATE_INEFFECTIVE||CHR(9)||
				C1.ASSIGNED_TO||CHR(9)||
				C1.TRANSACTION_HEADER_ID_OUT||CHR(9)||
				C1.TRANSACTION_UNITS||CHR(9)||
				C1.RETIREMENT_ID||CHR(9)||
				C1.LAST_UPDATE_LOGIN||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.CODE_COMBINATION_ID)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
